package listener

import (
	"context"
	"log"

	"git.3crabs.ru/save_my_money/smm_tg/internal/modules/messenger"
	"git.3crabs.ru/save_my_money/smm_tg/internal/services/bot"
)

type ListenerService struct {
	Messenger messenger.IMessenger
	Bots      []bot.IBot
}

func (s *ListenerService) Run(ctx context.Context) error {
	for {
		msg, err := s.Messenger.GetMessage(ctx)
		if err != nil {
			if err == context.Canceled {
				return nil
			}
			return err
		}
		for _, b := range s.Bots {
			if err := b.Process(ctx, msg); err != nil {
				log.Println(err)
			}
		}
	}
}
